Тёмный

Online Stock Span - Leetcode 901 - Python 

NeetCode
Подписаться 828 тыс.
Просмотров 32 тыс.
50% 1

Наука

Опубликовано:

 

4 окт 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 49   
@NeetCode
@NeetCode 2 года назад
Sorry the video cuts off before the code is complete, here's the full code: github.com/neetcode-gh/leetcode/blob/main/python/901-Online-Stock-Span.py
@karanssh
@karanssh 2 года назад
FYI, this link is 404 now, files got moved
@Neo-gy1bv
@Neo-gy1bv Год назад
WTF after spending 15 min i am stuck with half code
@Neo-gy1bv
@Neo-gy1bv Год назад
@@karanssh WTF after spending 15 min i am stuck with half code
@NamsInUsa
@NamsInUsa 11 месяцев назад
class StockSpanner: def __init__(self): self.stack = [] def next(self, price: int) -> int: span = 1 while self.stack and self.stack[-1][0]
@KaushikkrSarma
@KaushikkrSarma 3 месяца назад
@@Neo-gy1bv class StockSpanner: def __init__(self): self.stack = [] # [price,span] def next(self, price: int) -> int: span = 1 while self.stack and self.stack[-1][0]
@lettershere
@lettershere 2 года назад
Got this exact question, with a small twist, at an interview less than a month ago, did a very similar approach to get linear solution and got the job.
@artieschmidt3039
@artieschmidt3039 2 года назад
lets goooo mario!! What job did you get?
@ashutoshjha2648
@ashutoshjha2648 3 месяца назад
Lucky broo
@qj3690
@qj3690 Год назад
class StockSpanner: def __init__(self): self.stack = [] def next(self, price: int) -> int: span = 1 while self.stack and price >= self.stack[-1][0]: span += self.stack[-1][1] self.stack.pop() self.stack.append([price, span]) return self.stack[-1][1] Thank you neetcode
@whatuphere
@whatuphere 8 месяцев назад
correction-- while self.stack and price > self.stack[-1][0]:
@estifanosbireda1892
@estifanosbireda1892 2 года назад
5 minutes in and I understand what u mean, u make such a good videos. I even sometimes watch your solutions for questions I already did.
@thecommondude
@thecommondude 2 года назад
Really ingenious solution! Didn't expect this to be solved via a stack!
@thanirmalai
@thanirmalai 2 года назад
Thank you very much. I finally understood monotonic stack. Neetcode is a true legend
@dollyvishwakarma2
@dollyvishwakarma2 2 года назад
@NeetCode Please make a videos on monotonic increasing/decreasing sequences and their patterns in questions so that we can identify problems that will need a stack.
@sirmidor
@sirmidor 2 года назад
The video ends for me at 15:18, cutting off before the code is completed.
@NeetCode
@NeetCode 2 года назад
Sorry about that, here's the full code: github.com/neetcode-gh/leetcode/blob/main/python/901-Online-Stock-Span.py
@michelleyang1881
@michelleyang1881 2 года назад
Took me a while to understand why the time complexity is O(n). From my understanding, for each time we push a new [price, span] pair, the worst case time complexity should be O(n). However, if we consider pushing all the prices, the overall time complexity is still O(n). Because we only gonna push each pair once + pop each pair AT MOST ONCE. Great explanation!
@dadisuperman3472
@dadisuperman3472 2 года назад
That's not a linear time complexity. Read my comment to understand why.
@Moch117
@Moch117 Год назад
Pushing to a stack is O(1) We go through the entire elements in 1 pass, which is why its O(n)
@ken470
@ken470 Год назад
Nice approach ♥️ I thought of something(without using pair)what if we use a count variable that is set to 1 then we push an element in stack and if the stack was empty we push 1 to our ans array. If the top of stack has larger element than incoming element then we will also push 1 since there will be no consecutives. If the top has element smaller than our incoming element than we pop until larger element is found and increment the count and push this count to ans array now for the next element if it will be larger than previous element than then can use previous count and for the rest element we can pop again and add to count and push to ans this way we don't have to use pair..
@comble999
@comble999 2 года назад
Got a similar question at my phone interview last week, hopefully I came out the solution and pass it.
@janardannn
@janardannn 3 месяца назад
i had somehwhat like this in mind but didnt really drew it out, so was kind of hazy then i thought maybe its not feasible, so watching NC now
@shamsularefinsajib7778
@shamsularefinsajib7778 8 месяцев назад
Amazing explanation, hats off!!
@ygwg6145
@ygwg6145 Год назад
Maybe it is easier to push price/index pair to stack. Then span=currIndex-prevIndex.
@subramaniannk4255
@subramaniannk4255 10 месяцев назад
This is the best explanation, thanks
@Spedfree
@Spedfree 2 года назад
Which program is he using to write on his screen like so?
@NeetCode
@NeetCode 2 года назад
I use Paint3D
@auroshisray9140
@auroshisray9140 Год назад
Great video thanks!!
@Liv3fast
@Liv3fast 2 года назад
If it weren’t for the design implementation of the problem, couldn’t we just use a DP array?
@Liv3fast
@Liv3fast 2 года назад
Actually was able to still implement it, but I guess the stack is still better space complexity.
@girirajrdx7277
@girirajrdx7277 2 года назад
@@Liv3fast class Node: def __init__(self,index,span): self.index=index self.span=span def stockSpan(price, n=0) : #Your code goes here if len(price)==0: return [] highest=Node(0,1) lenn=len(price) span_data=[0]*lenn span_data[0]=1 i=1 while iprice[j]: count=count+highest.span highest.index=i highest.span=count span_data[i]=count break count=count+1 j=j-1 span_data[i]=count i=i+1 return span_data you can try this.....
@chaitu2037
@chaitu2037 2 года назад
As usual, amazing!
@__________________________6910
@__________________________6910 2 года назад
You are great
@paulo25740
@paulo25740 2 года назад
ha! what a neat solution
@minhthinhhuynhle9103
@minhthinhhuynhle9103 Год назад
11:19 What happened if the number is 65 instead ???
@user-jo1zj1vg4v
@user-jo1zj1vg4v Год назад
It would still be 1 because the problem states that we are looking for (consecutive) days since 70 is greater than 65.
@Nick-uo2bi
@Nick-uo2bi 2 года назад
Please introduce DSA and DP playlist for concept. It will help alot :)
@GauravKumar-sr6bt
@GauravKumar-sr6bt 2 года назад
@NeetCode Even though each element will be added and removed at Max one time, but the comparisons we had to make to compute span of a particular position can be more than 1. So time complexity would be O(n*n). Detailed explanation: what we are basically doing is summing up the spans of previous peeks, provided previous peeks are smaller than the current value for which we are computing span. E.g. if data is [1,5,10,2,4,9,4,5,8,13], then to compute the span of 13, we will have to sum up spans of previous peaks smaller than 13, i.e. span(8) + span(9) + span(10).
@jugsma6676
@jugsma6676 2 года назад
this is my solution, is this fine? def stock_spanner(stock: List) -> List: stack = [] for i, v in enumerate(stock): if i == 0: stack.append(1) else: prev = stock[i-1] jump = 1 while v > prev and jump > 0: jump += stack[i - jump] prev = stock[i-jump] stack.append(jump) return stack
@b_2818
@b_2818 Год назад
right?
@dadisuperman3472
@dadisuperman3472 2 года назад
That's not a linear solution time wise. By adding the stack you worsened the space complexity from O(1) to O(n), and without changing the time complexity which is in worse case scenario O(n2). You have just to compare the number of comparison you did in the stack solution against the jump solution. No difference! A list of spans is also a stack, but instead of popping the values you just jump the index using the spans. 🤷🏻‍♂️ Take this expls [40,30,20,10,90,80,70,60,50,100] [90, 80, 70, 60, 50, 40, 30, 20, 10, 100]
@jamesmandla1192
@jamesmandla1192 2 года назад
the number of comparisons should be the same regardless of whether you pop from the stack or simply jump indexes so I guess you're correct about space complexity. However in the examples you gave , the time complexity was still O(2n) which was the worst case he mentioned. For example, in the second solution you only have to start checking the elements beforehand once you reach 100 because all the immediate previous adjacent elements for the previous values are larger which means we can immediate move on and don't have to check the span.
@dadisuperman3472
@dadisuperman3472 2 года назад
@@jamesmandla1192 number of comparisons is the time complexity. 😏
@jamesmandla1192
@jamesmandla1192 2 года назад
@@dadisuperman3472 right, I just realised haha. But I think space complexity would be O(n) regardless of whether you used a stack because you would need to create an array to store the output right?
@dadisuperman3472
@dadisuperman3472 2 года назад
@@jamesmandla1192 nope
@shuhaoliang144
@shuhaoliang144 Год назад
Amortized time is O(1) for each call
Далее
How I would learn Leetcode if I could start over
18:03
Просмотров 566 тыс.
Remove K Digits - Leetcode 402 - Python
14:36
Просмотров 62 тыс.
Сколько стоит ПП?
00:57
Просмотров 343 тыс.
🦊🔥
00:16
Просмотров 789 тыс.
Open the Lock - Leetcode 752 - Python
14:22
Просмотров 40 тыс.
Decode String - Leetcode 394 - Python
16:26
Просмотров 87 тыс.
I Solved 1583 Leetcode Questions  Here's What I Learned
20:37
How do QR codes work? (I built one myself to find out)
35:13
Jump Game - Greedy - Leetcode 55
16:28
Просмотров 242 тыс.
I Solved 100 LeetCode Problems
13:11
Просмотров 62 тыс.
Snakes and Ladders - Leetcode 909 - Python
21:22
Просмотров 51 тыс.
L15. Stock Span Problem | Stack and Queue Playlist
19:21
Пустая коробка вместо iPhone 16 pro
1:00